// Copyright (C) 2005 Igor Bronnicov

import java.awt.*;
import java.applet.*;

public class liss extends Applet implements Runnable {	
	Thread myThread = null;
	Image img = null;
	Graphics gr;
	double x;
	double y;
	double st=0;
	int step=400;
	boolean up=false;
	boolean bCreated=false;
	Color c1,c2,c3,c4,c5;
	
	public void update(Graphics g){
		paint(g);
	}
	
	public void paint(Graphics g){
		if (!bCreated) {
			bCreated=true;
			img=this.createImage(320,200);
			gr=img.getGraphics();
		}
		gr.setColor(Color.white);
		gr.fillRect(0,0,320,200);
		gr.setColor(c4); drawStuff(st-3*Math.PI/30);
		gr.setColor(c3); drawStuff(st-2*Math.PI/30);
		gr.setColor(c2); drawStuff(st-1*Math.PI/30);
		gr.setColor(c1); drawStuff(st);		
		g.drawImage(img,0,0,null);
		
		st+=Math.PI/30;
		if (up){
			if (x>=9) {
				up=false; x-=1.0/step;
			} else x+=1.0/step;
		} else {
			if (x<=-9) {
				up=true; x+=1.0/step;
			} else x-=1.0/step;
		}
	}

	public void drawStuff(double st){
		int vx,vy;
		for (double fi=0;fi<2*Math.PI;fi+=2*Math.PI/step/4){
			vx=(int)(160+150*Math.cos(fi*x));
			vy=(int)(110-80*Math.sin(fi*y+st));
			gr.fillRect(vx,vy,2,2);
		}
	}

	public void init(){	
		c1=new Color(0,255,0);
		c2=new Color(63,255,63);
		c3=new Color(127,255,127);
		c4=new Color(191,255,191);
		c5=new Color(255,255,255);
		x = (double)(Integer.parseInt(getParameter("x")));
		y = (double)(Integer.parseInt(getParameter("y")));
	}

	public void start(){
		if(myThread == null){
			myThread = new Thread(this);
			myThread.start();
		}
	}
	public void stop(){
		if(myThread != null){
			myThread.stop();
			myThread = null;
		}
	}
	public void run() {
		while(true) {
			repaint();
			try {  this. myThread.sleep(25); } catch(InterruptedException e) {}
		}
	}	
}					

